Attribute VB_Name = "modDBF"
'Modu napisany na podstawie: artykuw M.P.Dworniczaka i C.Olszewskiego w PC Kurierze,
'(Dzial "Dla praktykw" (Pascal)), oraz opisu formatu DBase III (z internetu) i rnych
'fragmentw kodu w Pascalu.
'Uwaga: modul czyta wszystkie rekordy, takze te skasowane (z 1 bajtem rekordu = ASC(42))

'kontakt z autorem:
'Piotr Jaskulski (eskimo73@poczta.onet.pl, http://www.republika.pl/eskimo73/), Warszawa, 2000 r.

Option Explicit
Type DBFHeader 'nagwek pliku - 32 bajty
    DBType As Byte
    DBYear As Byte
    DBMonth As Byte
    DBDay As Byte
    DBRecCount As Long
    DBLocation As Integer
    DBRecordLen As Integer
    DBReserved As String * 19
    DBTerminator As String * 1
End Type

Type DBFField 'struktura pola
    Name As String * 10
    Terminator As String * 1
    Type As String * 1
    Adres As Long
    Size As Byte
    Separator As Byte
    Reserved As String * 14
End Type

Type DBF
   File As String 'nazwa pliku
   Type As String 'typ bazy
   NF As Byte 'liczba pol
   RecBuffer As String 'bufor do odczytu rekordu
End Type

Public DBFErrNum As Byte
Public HDBF As DBFHeader
Public FDBF() As DBFField
Public Baza As DBF

Const ErrorNone = 0 'brak bledow
Const ErrorZero = 1 'plik o zerowej dlugosci
Const ErrorRHead = 2 'blad przy wczytywaniu naglowka
Const ErrorNoDBF = 3 'to nie jest plik dBase III
Const ErrorHLocalization = 4 'bledny bajt poczatkowy polozenia danych w naglowku
Const ErrorLeng = 5 'bledna liczba rekordow
Const ErrorWHead = 6 'blad przy zapisie naglowka
Const ErrorRField = 7 'blad przy wczytywaniu pola
Const ErrorWField = 8 'blad przy zapisie pola

Function ReadHeader(strFile As String, Header As DBFHeader) As Boolean
On Error GoTo ErrHelp
Dim NP As Integer
 
NP = FreeFile

Open strFile For Binary As NP
   Get #NP, 1, Header
Close #NP
 
ReadHeader = True
Exit Function

ErrHelp:
   ReadHeader = False
   DBFErrNum = ErrorRHead

End Function


Function ReadField(strFile As String, Field As DBFField, NrPola As Byte) As Boolean
On Error GoTo ErrHelp
Dim NP As Integer
 
NP = FreeFile

Open strFile For Binary As NP
   Get #NP, 32 + (NrPola - 1) * 32 + 1, Field
Close #NP

ReadField = True
Exit Function

ErrHelp:
   ReadField = False
   DBFErrNum = ErrorRField
End Function

Function xtrim(Tekst As String) As String
Dim Znak1, nz, LenString

Tekst = Trim$(Tekst)
LenString = Len(Tekst)
Znak1 = ""
For nz = 1 To LenString
   If Asc(Mid$(Tekst, nz, 1)) <> 0 Then
      Znak1 = Znak1 + Mid$(Tekst, nz, 1)
   End If
Next
xtrim = Znak1
End Function
Sub ReadDBF()
Dim iFDBF As DBFField
Dim i As Byte, j As Byte
Dim Adres As Long

'czytanie nagwka
If Not ReadHeader(Baza.File, HDBF) Then Exit Sub

Baza.NF = (HDBF.DBLocation - 32 + 1) / 32
ReDim FDBF(1 To Baza.NF) As DBFField

'czytanie struktury pl
For i = 1 To Baza.NF
   If Not ReadField(Baza.File, iFDBF, i) Then Exit Sub
   FDBF(i) = iFDBF
   Adres = 0
   If i > 1 Then
      For j = 1 To i - 1
         Adres = Adres + FDBF(j).Size
      Next
   End If
   FDBF(i).Adres = Adres + 2
Next

For i = 1 To Baza.NF
   FDBF(i).Name = Trim$(xtrim(FDBF(i).Name))
Next

'sprawdzenie nagwka
If HDBF.DBLocation <> 32 + Baza.NF * 32 + 1 Then
   DBFErrNum = ErrorHLocalization
   Exit Sub
End If

Select Case HDBF.DBType
   Case 3
      Baza.Type = "dBase III"
   Case 131
      Baza.Type = "dBase III z polami Memo"
   Case Else
      Baza.Type = "To nie jest plik DBase III!"
      DBFErrNum = ErrorNoDBF
      Exit Sub
End Select

'przygotowanie bufora rekordu
Baza.RecBuffer = String(HDBF.DBRecordLen, " ")

End Sub
Sub GetRecord(NumRec As Long)
Dim Fnum As Long
Dim poz As Long

Fnum = FreeFile
Open Baza.File For Binary As Fnum
   poz = HDBF.DBLocation + (NumRec - 1) * HDBF.DBRecordLen + 1 'plus jeden -znacznik konca nagwka (kod #13)
   Get #Fnum, poz, Baza.RecBuffer 'wczytanie rekordu
Close #Fnum
End Sub

Function GetField(NumField As Long) As String
GetField = Mid(Baza.RecBuffer, FDBF(NumField).Adres, FDBF(NumField).Size)
End Function

Function GetFieldType(NumField As Long) As String
GetFieldType = FDBF(NumField).Type
End Function

Function GetFieldSize(NumField As Long) As Byte
GetFieldSize = FDBF(NumField).Size
End Function

Function GetFieldByName(FieldName As String) As String
Dim i As Long, NumField As Long

For i = 1 To Baza.NF
   If FieldName = Trim$(FDBF(i).Name) Then
      NumField = i
      Exit For
   End If
Next
 
GetFieldByName = GetField(NumField)
 
End Function
