Attribute VB_Name = "modFileOpen"
Option Explicit

Public Const OFN_EXPLORER = &H80000
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_OVERWRITEPROMPT = &H2

Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  Flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Sub ExportData()
'------------------------------------------------
'Procedura do eksportu danych do pliku tekstowego
'------------------------------------------------
If gAnaliza = 1 Then  'zabezpieczenie przed wykonaniem
   Beep               'podczas pracy algorytmu genetycznego
   Exit Sub
End If

Dim i As Integer, j As Integer, c As String, NP As Integer
Dim Wiersz As String
Dim strFile As String

'Call CenterForm(frmMDI, frmExportOptions)
frmExportOptions.Show vbModal
DoEvents
If Decyzja = -99 Then Exit Sub

strFile = ShowSave(frmMDI.hwnd, "txt file (*.txt)" + Chr$(0) + "*.txt" + Chr$(0) + "all (*.*)" + Chr$(0) + "*.*" + Chr$(0), App.Title + " - Export *.txt file", "txt")
If strFile = "" Then
   Exit Sub
End If

NP = FreeFile

Select Case ECommaType
  Case 1
    c = ";"
  Case 2
    c = ","
  Case 3
    c = Chr$(9)
End Select

On Error Resume Next

' open the file
Open strFile For Output As #NP

' display hourglass
Screen.MousePointer = vbHourglass

' sekcja nazw cech
If InsertVariable = 1 Then
   frmMDI.ActiveForm.Grid1.Row = 0
   Wiersz = ""
   For j = 2 To frmMDI.ActiveForm.Grid1.Cols - 1
      frmMDI.ActiveForm.Grid1.Col = j
      If Wiersz <> "" Then
         Wiersz = Wiersz + c + Trim$(frmMDI.ActiveForm.Grid1.Text)
      Else
         Wiersz = Trim$(frmMDI.ActiveForm.Grid1.Text)
      End If
   Next
   Print #NP, Wiersz
   Wiersz = ""
End If

' sekcja rekordw - w wierszu najpierw opis obiektu,
' dalej dane
For i = 1 To frmMDI.ActiveForm.Grid1.Rows - 1
   frmMDI.ActiveForm.Grid1.Row = i
   For j = 1 To frmMDI.ActiveForm.Grid1.Cols - 1
      frmMDI.ActiveForm.Grid1.Col = j
      If frmMDI.ActiveForm.Grid1.Col = frmMDI.ActiveForm.Grid1.Cols - 1 Then
         Wiersz = Wiersz & frmMDI.ActiveForm.Grid1.Text
      Else
         Wiersz = Wiersz & frmMDI.ActiveForm.Grid1.Text & c
      End If
   Next
   Print #NP, Wiersz
   Wiersz = ""
Next

Close #NP

' reset the mousepointer
Screen.MousePointer = vbDefault

If Err Then
   MsgBox Error, 48, App.Title
End If
End Sub

Sub ExportDataToExcel()
'*********************************************************
'Procedura ExportDataToExcel zapisuje dane do pliku Excel 2.1
'*********************************************************
Dim strFile As String
Dim i As Long, j As Long

strFile = ShowSave(frmMDI.hwnd, "xls file (*.xls)" + Chr$(0) + "*.xls" + Chr$(0), App.Title + " - Export to Excel", "")
If strFile = "" Then
   Exit Sub
End If

' set the mousepointer
Screen.MousePointer = vbHourglass

Dim myExcelFile As New ExcelFile

With myExcelFile
    'Create the new spreadsheet
    .CreateFile strFile
    .PrintGridLines = True
    .SetMargin xlsTopMargin, 1.5   'set to 1.5 inches
    .SetMargin xlsLeftMargin, 1.5
    .SetMargin xlsRightMargin, 1.5
    .SetMargin xlsBottomMargin, 1.5
    .SetDefaultRowHeight 14
    
    .SetFont "Courier New", 10, xlsNoFormat              'xlsFont0
    .SetFont "Courier New", 10, xlsBold                  'xlsFont1
    .SetFont "Courier New", 10, xlsBold + xlsUnderline   'xlsFont2
    .SetFont "Courier New", 10, xlsBold + xlsItalic      'xlsFont3
    .SetColumnWidth 1, 1, 18
    .SetColumnWidth 2, frmMDI.ActiveForm.Grid1.Cols - 1, 8
                        
    frmMDI.ActiveForm.Grid1.Row = 0
    For i = 1 To frmMDI.ActiveForm.Grid1.Cols - 1
       frmMDI.ActiveForm.Grid1.Col = i
       .WriteValue xlsText, xlsFont0, xlsleftAlign, xlsNormal, 1, i, frmMDI.ActiveForm.Grid1.Text
    Next
                       
    For i = 1 To frmMDI.ActiveForm.Grid1.Rows - 1
        frmMDI.ActiveForm.Grid1.Row = i
        For j = 1 To frmMDI.ActiveForm.Grid1.Cols - 1
            frmMDI.ActiveForm.Grid1.Col = j
            If j = 1 Then
                .WriteValue xlsText, xlsFont0, xlsleftAlign, xlsNormal, i + 1, 1, frmMDI.ActiveForm.Grid1.Text
            Else
                .WriteValue xlsnumber, xlsFont0, xlsrightAlign, xlsNormal, i + 1, j, frmMDI.ActiveForm.Grid1.Text
            End If
        Next
    Next
                
    .CloseFile
End With

' reset the mousepointer
Screen.MousePointer = vbDefault

End Sub

Sub FDiagramProc()
'procedura po poleceniu Odczytaj diagram
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

Dim strFile As String
strFile = ShowOpen(frmMDI.hwnd, "dgr file (*.dgr)" + Chr$(0) + "*.dgr" + Chr$(0) + "all (*.*)" + Chr$(0) + "*.*" + Chr$(0), App.Title + " - Select dgr file")
If strFile = "" Then
   Exit Sub
End If

DoEvents
Call UpdateFileMenu(strFile)
Call OpenDiagramNew(strFile)
End Sub

Sub OpenDiagramB(FileName As String)
'funkcja odczytuje plik z diagramem
Dim Wiersz As String * 15
Dim c As Integer, p As Integer, i As Integer
Dim j As Integer, k As Integer
Dim Zmienna
Dim OpisDiagramu As String * 50
Dim Liczba As Integer
Dim LiczbaSingle As Single
Dim ArkuszWidth As Long, ArkuszHeight As Long
ReDim Przedzial(1 To 4) As Single

p = FreeFile
'On Error GoTo OpenErrorDiagram

Open FileName For Binary As #p

OpisDiagramu = String$(50, " ")
Get #p, 1, OpisDiagramu

Get #p, 51, Liczba
ArkuszWidth = Liczba

Get #p, 55, Liczba
ArkuszHeight = Liczba

For i = 1 To 4
   c = 59 + (i - 1) * 4
   Get #p, c, LiczbaSingle
   Przedzial(i) = LiczbaSingle
Next

ReDim DaneMaczka(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim RecInfo(1 To ArkuszHeight)
ReDim Etykiety(1 To ArkuszWidth)
Dim SzerRekord

SzerRekord = 15 + ArkuszWidth * 4
For i = 1 To ArkuszHeight
   c = 75 + ((i - 1) * SzerRekord)
   Wiersz = String$(15, " ")
   Get #p, c, Wiersz
   RecInfo(i) = LTrim$(RTrim$(Wiersz))
   For j = 1 To ArkuszWidth
      c = 75 + (i - 1) * SzerRekord + 15 + (j - 1) * 4
      Get #p, c, LiczbaSingle
      DaneMaczka(i, j) = LiczbaSingle
   Next
Next

Dim Wiersz3 As String * 8

For i = 1 To ArkuszWidth
   Wiersz3 = String$(8, " ")
   Get #p, , Wiersz3
   Etykiety(i) = LTrim$(RTrim$(Wiersz3))
Next
   
Get #p, , Liczba
DystansType = Liczba

If DystansType = 6 Then
   Get #p, , Liczba
   Par_R = Liczba
   Get #p, , Liczba
   Par_P = Liczba
End If

Close #p

'ReDim Dys_S(1 To ArkuszHeight)
'ReDim Dys_P(1 To ArkuszHeight)
'ReDim Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)

'obliczenie macierzy odlegoci
ReDim Dystans(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim Obiekt_A(1 To ArkuszWidth)
ReDim Obiekt_B(1 To ArkuszWidth)

For i = 1 To ArkuszHeight
   For j = 1 To ArkuszHeight
      For k = 1 To ArkuszWidth
         Obiekt_A(k) = DaneMaczka(i, k)
         Obiekt_B(k) = DaneMaczka(j, k)
      Next
      If i = j Then
         Dystans(i, j) = 0
      ElseIf i < j Then
         Dystans(i, j) = ObliczDystans(Obiekt_A(), Obiekt_B(), ArkuszWidth)
      ElseIf i > j Then
         Dystans(i, j) = Dystans(j, i)
      End If
   Next
Next

Przekaznik = ArkuszHeight
Przekaznik2 = ArkuszWidth

Screen.MousePointer = vbHourglass

Dim fIndex As Integer
fIndex = 0
fIndex = CFindFreeIndex()
gIndex = fIndex
DiagPar(fIndex).Height = ArkuszHeight
DiagPar(fIndex).Width = ArkuszWidth
Diagram(fIndex).Tag = fIndex
Diagram(fIndex).Caption = "[DIAGRAM]: " & FileName
Diagram(fIndex).BottomText = LTrim$(RTrim$(OpisDiagramu))
ReDim DiagPar(fIndex).Distance(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim DiagPar(fIndex).Data(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim DiagPar(fIndex).Etykiety(1 To ArkuszWidth)
ReDim DiagPar(fIndex).RecInfo(1 To ArkuszHeight)
ReDim DiagPar(fIndex).Przedzial(1 To 4)
ReDim DiagPar(fIndex).Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)
DiagPar(fIndex).DistanceType = DystansType
DiagPar(fIndex).RodzajDiagramu = RodzajDiagramu
DiagPar(fIndex).MatrixOnly = False

'zapis macierzy odleglosci do wewnetrznej tablicy diagramu
For i = 1 To DiagPar(fIndex).Height
   For j = 1 To DiagPar(fIndex).Height
      DiagPar(fIndex).Distance(i, j) = Dystans(i, j)
   Next
Next

'zapis danych do wewnetrznej tablicy diagramu
For i = 1 To DiagPar(fIndex).Height
   For j = 1 To DiagPar(fIndex).Width
      DiagPar(fIndex).Data(i, j) = DaneMaczka(i, j)
   Next
Next

'zapis etykiet (nazw) cech do wewnetrznej tablicy diagramu
For i = 1 To DiagPar(fIndex).Width
   DiagPar(fIndex).Etykiety(i) = Etykiety(i)
Next

'zapis nazw rekordw to tablicy wewnetrznej diagramu
For i = 1 To DiagPar(fIndex).Height
   DiagPar(fIndex).RecInfo(i) = RecInfo(i)
Next

'zapis granic przedzialow do wewnetrznej tablicy diagramu
For i = 1 To 4
   DiagPar(fIndex).Przedzial(i) = Val(Przedzial(i))
Next

'zapis macierzy do okna
For i = 1 To DiagPar(fIndex).Height
   For j = 1 To DiagPar(fIndex).Height
      If DiagPar(fIndex).Distance(i, j) >= 0 And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(1) Then
         DiagPar(fIndex).Grupa(i, j) = 5
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(1) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(2) Then
         DiagPar(fIndex).Grupa(i, j) = 4
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(2) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(3) Then
         DiagPar(fIndex).Grupa(i, j) = 3
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(3) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(4) Then
         DiagPar(fIndex).Grupa(i, j) = 2
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(4) Then
         DiagPar(fIndex).Grupa(i, j) = 1
      Else
         DiagPar(fIndex).Grupa(i, j) = 6
      End If
   Next
Next
    
Diagram(fIndex).Siatka.Cols = DiagPar(fIndex).Height + 2
Diagram(fIndex).Siatka.Rows = DiagPar(fIndex).Height + 1
Diagram(fIndex).Siatka.FontBold = False
If ArkuszHeight > 99 Then
   Diagram(fIndex).Siatka.FontSize = 7
Else
   Diagram(fIndex).Siatka.FontSize = 8
End If
        
Diagram(fIndex).Siatka.ColAlignment(1) = 0
For i = 2 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.ColAlignment(i) = 2
Next

Diagram(fIndex).Siatka.Row = 0
For i = 2 To DiagPar(fIndex).Height + 1
   Diagram(fIndex).Siatka.Col = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(0) = Diagram(fIndex).picColor01.Height
   Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i - 1)))
Next
    
Diagram(fIndex).Siatka.Col = 0
For i = 0 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
Next

Diagram(fIndex).Siatka.Col = 0
For i = 1 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
   Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i)))
Next

Diagram(fIndex).Siatka.Col = 1
For i = 0 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(1) = 1800
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
   If i = 0 Then Diagram(fIndex).Siatka.Text = "Name"
   If i >= 1 Then Diagram(fIndex).Siatka.Text = RecInfo(i)
Next

For i = 1 To DiagPar(fIndex).Height
   For j = 2 To DiagPar(fIndex).Height + 1
      Diagram(fIndex).Siatka.Row = i
      Diagram(fIndex).Siatka.Col = j
      Diagram(fIndex).Siatka.COLWIDTH(j) = Diagram(fIndex).picColor01.Width
      Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
      
      Select Case DiagPar(fIndex).Grupa(i, j - 1)
         Case 1
            Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor01.Picture
         Case 2
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor02.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle02.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic02.Picture
            End If
         Case 3
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor03.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle03.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic03.Picture
            End If
         Case 4
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor04.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle04.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic04.Picture
            End If
         Case 5
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor05.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle05.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic05.Picture
            End If
         Case 0
            Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor06.Picture
      End Select
      
  Next
Next

'------------
CState(fIndex).Dirty = True
Diagram(fIndex).WindowState = vbMaximized
If Diagram(fIndex).WindowState = 0 Then
   Diagram(fIndex).Width = 0.98 * Screen.Width
   Diagram(fIndex).Height = 0.83 * Screen.Height
   Diagram(fIndex).Left = 0
   Diagram(fIndex).Top = 0
End If
'DoEvents
Diagram(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault
Exit Sub

OpenErrorDiagram:
   MsgBox "Diagram Error!", 0 + 16
   Exit Sub
End Sub

Public Sub OpenDiagramNew(strFile As String)
Dim p As Integer
Dim intLoc As Integer, i As Integer, j As Integer
Dim strTemp As String
Dim intType As Integer        ' Type
Dim strDescription As String  ' Description
Dim intRecCount As Integer    ' Record Count
Dim intVarCount As Integer    ' Variable Count
Dim sngSecLimit_1 As Single   ' Section Limit 1
Dim sngSecLimit_2 As Single   ' Section Limit 2
Dim sngSecLimit_3 As Single   ' Section Limit 3
Dim sngSecLimit_4 As Single   ' Section Limit 4
Dim intDistType As Integer    ' Distance Type
Dim intDiagType As Integer    ' Diagram Type
Dim intPar_R As Integer       ' Par_R
Dim intPar_P As Integer       ' Par_P

p = FreeFile
Open strFile For Input As #p
Line Input #p, strTemp

If Left$(strTemp, 14) <> "MaCzek DIAGRAM" Then
   MsgBox "This file has been created in older MaCzek version. You can save it only with new format.", vbExclamation, "MaCzek"
   Close #p
   Call OpenDiagramB(strFile)
   Exit Sub
End If

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[HEADER]" Then
   MsgBox "Error in HEADER section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "Type" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intType = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "Description" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   strDescription = strTemp
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "RecCount" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intRecCount = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "VarCount" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intVarCount = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "SecLimit_1" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   sngSecLimit_1 = CSng(Val(strTemp))
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "SecLimit_2" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   sngSecLimit_2 = CSng(Val(strTemp))
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "SecLimit_3" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   sngSecLimit_3 = CSng(Val(strTemp))
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "SecLimit_4" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   sngSecLimit_4 = CSng(Val(strTemp))
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "DistType" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intDistType = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "DiagType" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intDiagType = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "Par_R" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intPar_R = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "Par_P" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intPar_P = CInt(strTemp)
End If

Line Input #p, strTemp 'empty line
Line Input #p, strTemp

If Trim$(strTemp) <> "[RECORD_LABEL]" Then
   MsgBox "Error in RECORD_LABEL section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

ReDim RecInfo(1 To intRecCount)

For i = 1 To intRecCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   If Len(strTemp) > 15 Then strTemp = Left$(strTemp, 15)
   RecInfo(i) = Trim$(strTemp)
Next

Line Input #p, strTemp 'empty line
Line Input #p, strTemp

If Trim$(strTemp) <> "[VARIABLE_LABEL]" Then
   MsgBox "Error in VARIABLE_LABEL section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

If intType = 0 Then
   ReDim Etykiety(1 To intVarCount)
   For i = 1 To intVarCount
      Line Input #p, strTemp
      strTemp = Trim$(strTemp)
      If Len(strTemp) > 8 Then strTemp = Left$(strTemp, 8)
      Etykiety(i) = strTemp
   Next
Else
   Line Input #p, strTemp
   If Trim$(strTemp) <> "N/A" Then
      MsgBox "Unexpected symbol in VARIABLE_LABEL section.", vbExclamation, "MaCzek"
      Close #p
      Exit Sub
   End If
End If

Line Input #p, strTemp 'empty line
Line Input #p, strTemp

ReDim gDataRecNA(1 To intRecCount)

If Trim$(strTemp) <> "[DATA]" Then
   MsgBox "Error in DATA section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

Dim strTempArray() As String

If intType = 0 Then
   ReDim DaneMaczka(1 To intRecCount, 1 To intVarCount)
   For i = 1 To intRecCount
      Line Input #p, strTemp
      strTemp = Trim$(strTemp)
      strTempArray = Split(strTemp, ";")
      For j = 1 To intVarCount
         If Trim$(strTempArray(j - 1)) <> "N/A" Then
            DaneMaczka(i, j) = CSng(Val(strTempArray(j - 1)))
         Else
            ' brak danych
            DaneMaczka(i, j) = gEmpty
            gDataRecNA(i) = True
            gDataNA = True
         End If
      Next
   Next
Else
   Line Input #p, strTemp
   If Trim$(strTemp) <> "N/A" Then
      MsgBox "Unexpected symbol in DATA section.", vbExclamation, "MaCzek"
      Close #p
      Exit Sub
   End If
End If

Line Input #p, strTemp 'empty line
Line Input #p, strTemp

If Trim$(strTemp) <> "[MATRIX]" Then
   MsgBox "Error in MATRIX section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

ReDim Dystans(1 To intRecCount, 1 To intRecCount)

For i = 1 To intRecCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   strTempArray = Split(strTemp, ";")
   For j = 1 To intRecCount
      Dystans(i, j) = CSng(Val(strTempArray(j - 1)))
   Next
Next

Close #p

Dim fIndex As Integer
fIndex = 0
fIndex = CFindFreeIndex()
gIndex = fIndex
DiagPar(fIndex).Height = intRecCount
DiagPar(fIndex).Width = intVarCount
Diagram(fIndex).Tag = fIndex
Diagram(fIndex).Caption = "[DIAGRAM]: " & strFile
Diagram(fIndex).BottomText = strDescription
ReDim DiagPar(fIndex).Distance(1 To intRecCount, 1 To intRecCount)
If intType = 0 Then
   ReDim DiagPar(fIndex).Data(1 To intRecCount, 1 To intVarCount)
   ReDim DiagPar(fIndex).Etykiety(1 To intVarCount)
End If
ReDim DiagPar(fIndex).RecInfo(1 To intRecCount)
ReDim DiagPar(fIndex).Przedzial(1 To 4)
ReDim DiagPar(fIndex).Grupa(1 To intRecCount, 1 To intRecCount)
ReDim DiagPar(fIndex).DataRecNA(1 To intRecCount)

For i = 1 To intRecCount
    DiagPar(fIndex).DataRecNA(i) = gDataRecNA(i)
Next

DiagPar(fIndex).DistanceType = intDistType
DiagPar(fIndex).RodzajDiagramu = intDiagType
If intType = 0 Then
   DiagPar(fIndex).MatrixOnly = False
ElseIf intType = 1 Then
   DiagPar(fIndex).MatrixOnly = True
End If

'zapis macierzy odleglosci do wewnetrznej tablicy diagramu
For i = 1 To DiagPar(fIndex).Height
   For j = 1 To DiagPar(fIndex).Height
      DiagPar(fIndex).Distance(i, j) = Dystans(i, j)
   Next
Next

'zapis danych do wewnetrznej tablicy diagramu
For i = 1 To DiagPar(fIndex).Height
   For j = 1 To DiagPar(fIndex).Width
      DiagPar(fIndex).Data(i, j) = DaneMaczka(i, j)
   Next
Next

'zapis etykiet (nazw) cech do wewnetrznej tablicy diagramu
For i = 1 To DiagPar(fIndex).Width
   DiagPar(fIndex).Etykiety(i) = Etykiety(i)
Next

'zapis nazw rekordw to tablicy wewnetrznej diagramu
For i = 1 To DiagPar(fIndex).Height
   DiagPar(fIndex).RecInfo(i) = RecInfo(i)
Next

'zapis granic przedzialow do wewnetrznej tablicy diagramu
DiagPar(fIndex).Przedzial(1) = sngSecLimit_1
DiagPar(fIndex).Przedzial(2) = sngSecLimit_2
DiagPar(fIndex).Przedzial(3) = sngSecLimit_3
DiagPar(fIndex).Przedzial(4) = sngSecLimit_4

'zapis macierzy do okna
For i = 1 To DiagPar(fIndex).Height
   For j = 1 To DiagPar(fIndex).Height
      If DiagPar(fIndex).Distance(i, j) >= 0 And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(1) Then
         DiagPar(fIndex).Grupa(i, j) = 5
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(1) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(2) Then
         DiagPar(fIndex).Grupa(i, j) = 4
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(2) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(3) Then
         DiagPar(fIndex).Grupa(i, j) = 3
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(3) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(4) Then
         DiagPar(fIndex).Grupa(i, j) = 2
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(4) Then
         DiagPar(fIndex).Grupa(i, j) = 1
      Else
         DiagPar(fIndex).Grupa(i, j) = 6
      End If
   Next
Next
    
Diagram(fIndex).Siatka.Cols = DiagPar(fIndex).Height + 2
Diagram(fIndex).Siatka.Rows = DiagPar(fIndex).Height + 1
Diagram(fIndex).Siatka.FontBold = False
If DiagPar(fIndex).Height > 99 Then
   Diagram(fIndex).Siatka.FontSize = 7
Else
   Diagram(fIndex).Siatka.FontSize = 8
End If
        
Diagram(fIndex).Siatka.ColAlignment(1) = 0
For i = 2 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.ColAlignment(i) = 2
Next

Diagram(fIndex).Siatka.Row = 0
For i = 2 To DiagPar(fIndex).Height + 1
   Diagram(fIndex).Siatka.Col = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(0) = Diagram(fIndex).picColor01.Height
   Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i - 1)))
Next
    
Diagram(fIndex).Siatka.Col = 0
For i = 0 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
Next

Diagram(fIndex).Siatka.Col = 0
For i = 1 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
   Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i)))
Next

Diagram(fIndex).Siatka.Col = 1
For i = 0 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(1) = 1800
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
   If i = 0 Then Diagram(fIndex).Siatka.Text = "Name"
   If i >= 1 Then Diagram(fIndex).Siatka.Text = RecInfo(i)
Next

For i = 1 To DiagPar(fIndex).Height
   For j = 2 To DiagPar(fIndex).Height + 1
      Diagram(fIndex).Siatka.Row = i
      Diagram(fIndex).Siatka.Col = j
      Diagram(fIndex).Siatka.COLWIDTH(j) = Diagram(fIndex).picColor01.Width
      Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
      
      Select Case DiagPar(fIndex).Grupa(i, j - 1)
         Case 1
            Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor01.Picture
         Case 2
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor02.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle02NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle02.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic02.Picture
            End If
         Case 3
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor03.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle03NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle03.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic03.Picture
            End If
         Case 4
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor04.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle04NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle04.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic04.Picture
            End If
         Case 5
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor05.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle05NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle05.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic05.Picture
            End If
         Case 0
            Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor06.Picture
      End Select
      
  Next
Next

'------------
CState(fIndex).Dirty = False
Diagram(fIndex).WindowState = vbNormal
If Diagram(fIndex).WindowState = 0 Then
   Diagram(fIndex).Width = 0.9 * Screen.Width
   Diagram(fIndex).Height = 0.75 * Screen.Height
   Diagram(fIndex).Left = 0
   Diagram(fIndex).Top = 0
End If

Diagram(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub

Sub FMatrixProc()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

Dim strFile As String
strFile = ShowOpen(frmMDI.hwnd, "mtx file (*.mtx)" + Chr$(0) + "*.mtx" + Chr$(0) + "all (*.*)" + Chr$(0) + "*.*" + Chr$(0), App.Title + " - Select mtx file")
If strFile = "" Then
   Exit Sub
End If

DoEvents
UpdateFileMenu strFile
OpenMatrixNew strFile

End Sub

Sub OpenMatrixB(FileName As String)
Dim NP As Integer, i As Integer, j As Integer, k As Integer
Dim c As Integer, Liczba As Integer, ArkuszHeight As Long
Dim Zmienna
Dim OpisMacierzy As String * 50
Dim LiczbaSingle As Single
Dim SzerRekord
Dim Wiersz As String * 50
NP = FreeFile

Screen.MousePointer = vbHourglass

Open FileName For Binary As #NP

' sekcja opisu pliku
Wiersz = String$(50, " ")
Get #NP, 1, Wiersz
OpisMacierzy = Wiersz

' sekcja wysokoci arkusza danych
Get #NP, 51, Liczba
ArkuszHeight = Liczba

ReDim DystansMatrix(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim RecInfo(1 To ArkuszHeight)

SzerRekord = (15 + ArkuszHeight * 4)

Dim Wiersz2 As String * 15

' sekcja rekordw - w wierszu najpierw opis obiektu, dalej dane
For i = 1 To ArkuszHeight
   c = 55 + ((i - 1) * SzerRekord)
   Wiersz2 = String$(15, " ")
   Get #NP, c, Wiersz2
   RecInfo(i) = LTrim$(RTrim$(Wiersz2))
   For j = 1 To ArkuszHeight
      c = 55 + ((i - 1) * SzerRekord) + 15 + (j - 1) * 4
      Get #NP, c, LiczbaSingle
      DystansMatrix(i, j) = LiczbaSingle
   Next
Next

Close #NP

Dim Maksymalny
Maksymalny = 0
For i = 1 To ArkuszHeight
   For j = 1 To ArkuszHeight
      If DystansMatrix(i, j) >= Maksymalny Then
         Maksymalny = DystansMatrix(i, j)
      End If
   Next
Next

' change form's caption and display new text
Dim fIndex As Integer
fIndex = MFindFreeIndex()
gIndex = fIndex

MatPar(fIndex).Height = ArkuszHeight
ReDim MatPar(fIndex).Distance(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim MatPar(fIndex).RecInfo(1 To ArkuszHeight)

'zapis macierzy odleglosci do wewnetrznej tablicy macierzy
For i = 1 To MatPar(fIndex).Height
   For j = 1 To MatPar(fIndex).Height
      MatPar(fIndex).Distance(i, j) = DystansMatrix(i, j)
   Next
Next

For i = 1 To MatPar(fIndex).Height
   MatPar(fIndex).RecInfo(i) = RecInfo(i)
Next

Macierz(fIndex).Tag = fIndex
Macierz(fIndex).Caption = "[MATRIX]: " & FileName
Macierz(fIndex).BottomText = LTrim$(RTrim$(OpisMacierzy))
'zapis macierzy do okna
Macierz(fIndex).Siatka.Rows = ArkuszHeight + 1
Macierz(fIndex).Siatka.Cols = ArkuszHeight + 2

For i = 0 To ArkuszHeight + 1
   Macierz(fIndex).Siatka.FixedAlignment(i) = 2
Next

Macierz(fIndex).Siatka.Col = 0
For i = 1 To ArkuszHeight
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = i
Next

Macierz(fIndex).Siatka.Col = 1
Macierz(fIndex).Siatka.COLWIDTH(1) = Macierz(fIndex).Siatka.COLWIDTH(1) * 3
For i = 1 To ArkuszHeight
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = RecInfo(i)
Next

Dim intMaksymalny As Integer
intMaksymalny = Len(CStr(Maksymalny))

Macierz(fIndex).Siatka.Row = 0
For i = 2 To ArkuszHeight + 1
   Macierz(fIndex).Siatka.Col = i
   Macierz(fIndex).Siatka.ColAlignment(i) = 1
   If intMaksymalny <= 5 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 1.3
   ElseIf intMaksymalny = 6 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 1.5
   ElseIf intMaksymalny = 7 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 1.75
   ElseIf intMaksymalny = 8 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2
   ElseIf intMaksymalny = 9 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2.3
   ElseIf intMaksymalny = 10 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2.5
   ElseIf intMaksymalny >= 11 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2.75
   End If
   Macierz(fIndex).Siatka.Text = i - 1
Next

For i = 1 To ArkuszHeight
   For j = 2 To ArkuszHeight + 1
      Macierz(fIndex).Siatka.Row = i
      Macierz(fIndex).Siatka.Col = j
      Macierz(fIndex).Siatka.Text = Format$(DystansMatrix(i, j - 1), "###0.000")
   Next
Next

MState(fIndex).Dirty = True
Macierz(fIndex).WindowState = 0
If Macierz(fIndex).WindowState = 0 Then
   Macierz(fIndex).Width = 0.95 * Screen.Width
   Macierz(fIndex).Height = 0.8 * Screen.Height
   Macierz(fIndex).Left = 0
   Macierz(fIndex).Top = 0
End If
Macierz(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault

Exit Sub

OpenErrorDiagram2:
   MsgBox "Unexpected error in file: " & FileName, vbCritical, "MaCzek"
End Sub

Sub FOpenProc()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If
    
Dim strFile As String
strFile = ShowOpen(frmMDI.hwnd, "mdt file (*.mdt)" + Chr$(0) + "*.mdt" + Chr$(0) + "all (*.*)" + Chr$(0) + "*.*" + Chr$(0), App.Title + " - Select mdt file")
If strFile = "" Then
   Exit Sub
End If

Call OpenDataNew(strFile)
Call UpdateFileMenu(strFile)

End Sub

Function OnRecentFilesList(FileName) As Integer
Dim i As Integer 'counter var

For i = 1 To 4
  If frmMDI.mnuRecentFile(i).Caption = FileName Then
    OnRecentFilesList = True
    Exit Function
  End If
Next i
OnRecentFilesList = False
End Function

Sub OpenFileB(FileName)
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

'deklaracja zmiennych
Dim i As Integer, j As Integer, c As Integer
Dim Wiersz As String * 50
Dim Opis As String * 50
Dim p As Integer, Cechy As Integer, Rekordy  As Integer
Dim Liczba As Integer
Dim LiczbaSingle As Single
Dim SzerRekord As Integer

' display hourglass
Screen.MousePointer = vbHourglass

p = FreeFile
' open the file
Open FileName For Binary As #p

' sekcja opisu pliku
Wiersz = String$(50, " ")
Get #p, 1, Wiersz
Opis = Wiersz

' sekcja szerokoci arkusza danych
Get #p, 51, Liczba
Cechy = Liczba

' sekcja wysokoci arkusza danych
Get #p, 55, Liczba
Rekordy = Liczba

ReDim Etykiety(1 To Cechy) As String
ReDim DaneMaczka(1 To Rekordy, 1 To Cechy)
ReDim RecInfo(1 To Rekordy)

Dim Wiersz2 As String * 8

' sekcja nazw cech
For j = 1 To Cechy
   Wiersz2 = String$(8, " ")
   c = 59 + ((j - 1) * 8)
   Get #p, c, Wiersz2
   Etykiety(j) = Wiersz2
Next

SzerRekord = (15 + Cechy * 4)

Dim Wiersz3 As String * 15

' sekcja rekordw - w wierszu najpierw opis obiektu, dalej dane
For i = 1 To Rekordy
   c = 59 + (Cechy * 8) + ((i - 1) * SzerRekord)
   Wiersz3 = String$(15, " ")
   Get #p, c, Wiersz3
   RecInfo(i) = LTrim$(RTrim$(Wiersz3))
   For j = 1 To Cechy
      c = 59 + (Cechy * 8) + ((i - 1) * SzerRekord) + 15 + (j - 1) * 4
      Get #p, c, LiczbaSingle
      DaneMaczka(i, j) = LiczbaSingle
   Next
Next

Close #p

Dim fIndex As Integer

' change form's caption and display new data
fIndex = FindFreeIndex()
gIndex = fIndex
document(fIndex).Tag = fIndex
document(fIndex).Caption = "[DATA]: " & LCase$(FileName)
document(fIndex).OpisText = LTrim$(RTrim$(Opis))

'Just some code to make the grid interesting
document(fIndex).Grid1.Cols = Cechy + 2 'plus dwa poniewa dochodzi kolumna na etykiety
document(fIndex).Grid1.Rows = Rekordy + 1 'plus jeden poniewa dochodzi wiersz gowny z nazwami cech

document(fIndex).Grid1.Row = 0
document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.Text = "Number"

document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.COLWIDTH(0) = 900
Dim JakaSzer As Integer, x%, y%

JakaSzer = 900

For x% = 1 To document(fIndex).Grid1.Rows - 1
  document(fIndex).Grid1.Row = x%
  document(fIndex).Grid1.Text = Str$(x%) 'numery wierszy z rekordami
Next x%

document(fIndex).Grid1.FixedAlignment(0) = 2 'wyrodkowanie numerw

document(fIndex).Grid1.Row = 0
For x% = 1 To document(fIndex).Grid1.Cols - 1
  If x% = 1 Then
    document(fIndex).Grid1.COLWIDTH(x%) = 1800
    JakaSzer = JakaSzer + 1800
    document(fIndex).Grid1.FixedAlignment(x%) = 0      'left aligned
    document(fIndex).Grid1.ColAlignment(x%) = 0      'left aligned
  Else
    document(fIndex).Grid1.COLWIDTH(x%) = 900
    JakaSzer = JakaSzer + 900
    document(fIndex).Grid1.FixedAlignment(x%) = 1      'right aligned
    document(fIndex).Grid1.ColAlignment(x%) = 1      'right aligned
  End If
  document(fIndex).Grid1.Col = x%
  If x% = 1 Then
    document(fIndex).Grid1.Text = "Record Name"
  Else
    document(fIndex).Grid1.Text = Etykiety(x% - 1)
  End If
Next x%

document(fIndex).Grid1.Col = 0
For i = 1 To document(fIndex).Grid1.Cols - 1
  document(fIndex).Grid1.FixedAlignment(i) = 2
Next

document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
For x% = 1 To document(fIndex).Grid1.Rows - 1
  document(fIndex).Grid1.Row = x%
  document(fIndex).Grid1.Text = RecInfo(x%)
Next x%

'deklaracja formatu wprowadzanych danych
Dim Fmt$
Fmt$ = "###0.000"

For x% = 1 To document(fIndex).Grid1.Rows - 1
  For y% = 2 To document(fIndex).Grid1.Cols - 1
    document(fIndex).Grid1.Row = x%
    document(fIndex).Grid1.Col = y%
    document(fIndex).Grid1.Text = Format$(DaneMaczka(x%, y% - 1), Fmt$)
    'jesli szeroki tekst zwieksz szerokosc kolumny
    If Len(document(fIndex).Grid1.Text) > 8 Then
      document(fIndex).Grid1.COLWIDTH(y%) = 1200
    End If
  Next
Next

document(fIndex).Grid1.Visible = True
document(fIndex).TopPanel.Visible = True
document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
document(fIndex).Grid1.SetFocus
document(fIndex).SzerOkno = JakaSzer
document(fIndex).Grid1.SetFocus
FState(fIndex).Dirty = False
document(fIndex).WindowState = 0
document(fIndex).Height = 0.8 * Screen.Height
document(fIndex).Width = 0.95 * Screen.Width
document(fIndex).Top = 0
document(fIndex).Left = 0
document(fIndex).Show
    
' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub

Sub SaveFileAsB(FileName As String)
'If gAnaliza = 1 Then
'   Beep
'   Exit Sub
'End If

'deklaracja zmiennych
'Dim i As Integer, j As Integer, c As Integer
'Dim Wiersz As String * 50
'Dim p As Integer, Cechy As Integer, Rekordy  As Integer
'Dim Liczba As Integer
'Dim LiczbaSingle As Single
'Dim SzerRekord As Integer

'On Error Resume Next
'p = FreeFile
'FileName = LCase$(FileName)
'Open FileName For Input As #p

'If Err = 0 Then
'   Close #p
'   Kill FileName
'Else
'   Err = 0
'End If

'p = FreeFile
' open the file
'Open FileName For Binary As #p

' display hourglass
'Screen.MousePointer = vbHourglass

' sekcja opisu pliku
'If Len(frmMDI.ActiveForm.OpisText) = 50 Then
'   Wiersz = frmMDI.ActiveForm.OpisText
'ElseIf Len(frmMDI.ActiveForm.OpisText) > 50 Then
'   Wiersz = Left$(frmMDI.ActiveForm.OpisText, 50)
'ElseIf Len(frmMDI.ActiveForm.OpisText) < 50 Then
'   Wiersz = frmMDI.ActiveForm.OpisText + (String$(50 - Len(frmMDI.ActiveForm.OpisText), " "))
'End If

'Put #p, 1, Wiersz

' sekcja szerokoci arkusza danych
'Liczba = CInt(frmMDI.ActiveForm.Grid1.Cols - 2)
'cechy = Liczba
'Put #p, 51, Liczba

' sekcja wysokoci arkusza danych
'Liczba = CInt(frmMDI.ActiveForm.Grid1.Rows - 1)
'Rekordy = Liczba
'Put #p, 55, Liczba

'Dim Wiersz2 As String * 8

' sekcja nazw cech
'frmMDI.ActiveForm.Grid1.Row = 0
'For j = 2 To frmMDI.ActiveForm.Grid1.Cols - 1
'   frmMDI.ActiveForm.Grid1.Col = j
'   If Len(frmMDI.ActiveForm.Grid1.Text) = 8 Then
'      Wiersz2 = frmMDI.ActiveForm.Grid1.Text
'   ElseIf Len(frmMDI.ActiveForm.Grid1.Text) > 50 Then
'      Wiersz2 = Left$(frmMDI.ActiveForm.Grid1.Text, 8)
'   ElseIf Len(frmMDI.ActiveForm.Grid1.Text) < 8 Then
'      Wiersz2 = frmMDI.ActiveForm.Grid1.Text + (String$(8 - Len(frmMDI.ActiveForm.Grid1.Text), " "))
'   End If
'   c = 59 + ((j - 2) * 8)
'   Put #p, c, Wiersz2
'Next

'Dim Wiersz3 As String * 15

' sekcja rekordw - w wierszu najpierw opis obiektu, dalej dane
'For i = 1 To frmMDI.ActiveForm.Grid1.Rows - 1
'   frmMDI.ActiveForm.Grid1.Row = i
'   For j = 1 To frmMDI.ActiveForm.Grid1.Cols - 1
'      frmMDI.ActiveForm.Grid1.Col = j
'      If j = 1 Then
'         If Len(frmMDI.ActiveForm.Grid1.Text) = 15 Then
'            Wiersz3 = frmMDI.ActiveForm.Grid1.Text
'         ElseIf Len(frmMDI.ActiveForm.Grid1.Text) > 15 Then
'            Wiersz3 = Left$(frmMDI.ActiveForm.Grid1.Text, 15)
'         ElseIf Len(frmMDI.ActiveForm.Grid1.Text) < 15 Then
'            Wiersz3 = frmMDI.ActiveForm.Grid1.Text + (String$(15 - Len(frmMDI.ActiveForm.Grid1.Text), " "))
'         End If
'         SzerRekord = (15 + Cechy * 4)
'         c = 59 + (Cechy * 8) + ((i - 1) * SzerRekord)
'         Put #p, c, Wiersz3
'      Else
'         LiczbaSingle = CSng(frmMDI.ActiveForm.Grid1.Text)
'         If Err Then
'            Err = 0
'            LiczbaSingle = 0
'         End If
'         c = 59 + (Cechy * 8) + ((i - 1) * SzerRekord) + 15 + (j - 2) * 4
'         Put #p, c, LiczbaSingle
'      End If
'   Next
'Next

'Close #p

' reset the mousepointer
'Screen.MousePointer = vbDefault

'If Err Then
'   MsgBox Error, 48, App.Title
'Else
'   frmMDI.ActiveForm.Caption = "[DATA]: " & UCase$(FileName)
'  ' reset the dirty flag
'   FState(frmMDI.ActiveForm.Tag).Dirty = False
'End If

End Sub

Sub UpdateFileMenu(FileName)
Dim intRetVal As Integer

' Check if the open filename is already in the File menu control array.
intRetVal = OnRecentFilesList(FileName)
If Not intRetVal Then
' Write open filename to the registry.
  WriteRecentFiles (FileName)
End If
' Update the list of the most recently opened files in the File menu control array.
GetRecentFiles

End Sub

'*****************************************************
'Funkcja wyswietla okienko dialogowe - 'Odczytaj plik'
'*****************************************************
Function ShowOpen(hwndOwner As Long, sFilter As String, sTitle As String) As String
Dim OFName As OPENFILENAME

OFName.lStructSize = Len(OFName)
OFName.hwndOwner = hwndOwner
OFName.hInstance = App.hInstance
OFName.lpstrFilter = sFilter
OFName.lpstrFile = String(255, 0)
OFName.nMaxFile = 255
OFName.lpstrFileTitle = String(255, 0)
OFName.nMaxFileTitle = 255
OFName.lpstrTitle = sTitle
OFName.Flags = OFN_EXPLORER Or OFN_FILEMUSTEXIST
OFName.lpstrInitialDir = App.Path
If GetOpenFileName(OFName) Then
  ShowOpen = Left$(OFName.lpstrFile, InStr(1, OFName.lpstrFile, Chr$(0)) - 1)
End If
End Function

'*****************************************************
'Funkcja wyswietla okienko dialogowe - 'Zachowaj plik'
'*****************************************************
Function ShowSave(hwndOwner As Long, sFilter As String, sTitle As String, sDefExt As String) As String
Dim OFName As OPENFILENAME
OFName.lStructSize = Len(OFName)
OFName.hwndOwner = hwndOwner
OFName.hInstance = App.hInstance
OFName.lpstrFilter = sFilter
OFName.lpstrFile = String(255, 0)
OFName.nMaxFile = 255
OFName.lpstrFileTitle = String(255, 0)
OFName.nMaxFileTitle = 255
OFName.lpstrTitle = sTitle
OFName.lpstrDefExt = sDefExt
OFName.Flags = OFN_EXPLORER Or OFN_OVERWRITEPROMPT
OFName.lpstrInitialDir = App.Path
If GetSaveFileName(OFName) Then
  ShowSave = Left$(OFName.lpstrFile, InStr(1, OFName.lpstrFile, Chr$(0)) - 1)
End If
End Function

'***********************************************
'Funkcja sprawdza czy wskazany plik juz istnieje
'***********************************************
Function IsFile(NameOfFile As String) As Boolean
  IsFile = (Dir(NameOfFile) <> "")
End Function

Public Sub SaveData()
If gAnaliza = 1 Then
  Beep
  Exit Sub
End If
    
Dim strFile As String

strFile = frmMDI.ActiveForm.Caption
strFile = Replace$(strFile, "[MATRIX]: ", "")
strFile = Replace$(strFile, "[DATA]: ", "")
strFile = Replace$(strFile, "[DIAGRAM]: ", "")
strFile = Replace$(strFile, "[BITMAP]: ", "")

If InStr(strFile, "Untitled") Then
  ' The file hasn't been saved yet,
  ' get the filename, then call the
  ' save procedure
  strFile = ShowSave(frmMDI.hwnd, "mdt file (*.mdt)" + Chr$(0) + "*.mdt" + Chr$(0) + "all (*.*)" + Chr$(0) + "*.*" + Chr$(0), App.Title + " - Save mdt file", "mdt")
  If strFile = "" Then
    Exit Sub
  End If
Else
  ' The caption contains the name of the open file
End If

' call the save procedure, if Filename = Empty then
' the user selected Cancel in the Save As dialog, otherwise
' save the file
If strFile <> "" Then
  Call SaveDataNew(strFile)
End If

End Sub

Public Sub SaveDataAs()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If
    
Dim strFile As String

strFile = ShowSave(frmMDI.hwnd, "mdt file (*.mdt)" + Chr$(0) + "*.mdt" + Chr$(0) + "all (*.*)" + Chr$(0) + "*.*" + Chr$(0), App.Title + " - Save mdt file as", "mdt")
If strFile = "" Then
   Exit Sub
End If

If strFile <> "" Then Call SaveDataNew(strFile)
' Update the recent files menu
Call UpdateFileMenu(strFile)

End Sub

'---------------------------------------------------------------------------------------
' Procedure : OpenMatrixNew
' DateTime  : 03-03-25 21:42
' Author    : Piotr
' Purpose   : Open new (text format) matrix file
'---------------------------------------------------------------------------------------
'
Public Sub OpenMatrixNew(strFile As String)
Dim p As Integer
Dim intLoc As Integer, i As Integer, j As Integer
Dim strTemp As String
Dim strDescription As String  ' Description
Dim intRecCount As Integer    ' Record Count

p = FreeFile
Open strFile For Input As #p
Line Input #p, strTemp

If Left$(strTemp, 13) <> "MaCzek MATRIX" Then
   MsgBox "This file has been created in older MaCzek version. You can save it only with new format.", vbExclamation, "Maczek"
   Close #p
   Call OpenMatrixB(strFile)
   Exit Sub
End If

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[HEADER]" Then
   MsgBox "Error in HEADER section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "Description" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   strDescription = strTemp
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "RecCount" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intRecCount = CInt(strTemp)
End If

Dim fIndex As Integer
fIndex = MFindFreeIndex()
gIndex = fIndex

MatPar(fIndex).Height = intRecCount
ReDim MatPar(fIndex).Distance(1 To intRecCount, 1 To intRecCount)
ReDim MatPar(fIndex).RecInfo(1 To intRecCount)

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[RECORD_LABEL]" Then
   MsgBox "Error in RECORD_LABEL section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

For i = 1 To intRecCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   If Len(strTemp) > 15 Then strTemp = Left$(strTemp, 15)
   MatPar(fIndex).RecInfo(i) = Trim$(strTemp)
Next

Line Input #p, strTemp 'empty line
Line Input #p, strTemp

If Trim$(strTemp) <> "[MATRIX]" Then
   MsgBox "Error in MATRIX section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

Dim strTempArray() As String

For i = 1 To intRecCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   strTempArray = Split(strTemp, ";")
   For j = 1 To intRecCount
      MatPar(fIndex).Distance(i, j) = CSng(Val(strTempArray(j - 1)))
   Next
Next

Close #p

Macierz(fIndex).Tag = fIndex
Macierz(fIndex).Caption = "[MATRIX]: " & strFile
Macierz(fIndex).BottomText = LTrim$(RTrim$(strDescription))
'zapis macierzy do okna
Macierz(fIndex).Siatka.Rows = intRecCount + 1
Macierz(fIndex).Siatka.Cols = intRecCount + 2

For i = 0 To MatPar(fIndex).Height + 1
   Macierz(fIndex).Siatka.FixedAlignment(i) = 2
Next

Macierz(fIndex).Siatka.Col = 0
For i = 1 To MatPar(fIndex).Height
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = i
Next

Macierz(fIndex).Siatka.Col = 1
Macierz(fIndex).Siatka.COLWIDTH(1) = Macierz(fIndex).Siatka.COLWIDTH(1) * 3
For i = 1 To MatPar(fIndex).Height
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = MatPar(fIndex).RecInfo(i)
Next

Dim intMaksymalny As Integer
intMaksymalny = 0
For i = 1 To MatPar(fIndex).Height
   For j = 1 To MatPar(fIndex).Height
      If Len(CStr(MatPar(fIndex).Distance(i, j))) > intMaksymalny Then
         intMaksymalny = Len(CStr(MatPar(fIndex).Distance(i, j)))
      End If
   Next
Next

Macierz(fIndex).Siatka.Row = 0
For i = 2 To MatPar(fIndex).Height + 1
   Macierz(fIndex).Siatka.Col = i
   Macierz(fIndex).Siatka.ColAlignment(i) = 1
   If intMaksymalny <= 4 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i)
   Else
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * (1 + (intMaksymalny - 4) * 0.25)
   End If
   Macierz(fIndex).Siatka.Text = i - 1
Next

For i = 1 To MatPar(fIndex).Height
   For j = 2 To MatPar(fIndex).Height + 1
      Macierz(fIndex).Siatka.Row = i
      Macierz(fIndex).Siatka.Col = j
      Macierz(fIndex).Siatka.Text = Format$(MatPar(fIndex).Distance(i, j - 1), "###0.000")
   Next
Next

MState(fIndex).Dirty = False
Macierz(fIndex).WindowState = 0
If Macierz(fIndex).WindowState = 0 Then
   Macierz(fIndex).Width = 0.95 * Screen.Width
   Macierz(fIndex).Height = 0.8 * Screen.Height
   Macierz(fIndex).Left = 0
   Macierz(fIndex).Top = 0
End If
Macierz(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub

'---------------------------------------------------------------------------------------
' Procedure : SaveDataNew
' DateTime  : 03-03-26 00:21
' Author    : Piotr
' Purpose   : save data file in new text format
'---------------------------------------------------------------------------------------
'
Public Sub SaveDataNew(strFile As String)
'deklaracja zmiennych
Dim i As Integer, j As Integer
Dim p As Integer

'sprawdzenie czy istnieje plik
On Error Resume Next

p = FreeFile
Open strFile For Input As #p

If Err = 0 Then
   Close #p
   Kill strFile
Else
   Err = 0
End If

' display hourglass
Screen.MousePointer = vbHourglass

p = FreeFile
' open the file
Open strFile For Output As #p

Dim strTemp As String
'identyfikator pliku
Print #p, "MaCzek DATA " & App.Major & "." & App.Minor
Print #p, ""

'naglowek
Print #p, "[HEADER]"
' sekcja opisu pliku
Print #p, "Description=" & Trim$(frmMDI.ActiveForm.OpisText)
' sekcja ilosci rekordow i ilosci cech
Print #p, "RecCount=" & Format$(CInt(frmMDI.ActiveForm.Grid1.Rows - 1), "###0")
Print #p, "VarCount=" & Format$(CInt(frmMDI.ActiveForm.Grid1.Cols - 2), "###0")

Print #p, ""

'etykiety rekordow
Print #p, "[RECORD_LABEL]"
For i = 1 To frmMDI.ActiveForm.Grid1.Rows - 1
   frmMDI.ActiveForm.Grid1.Row = i
   frmMDI.ActiveForm.Grid1.Col = 1
   Print #p, Trim$(frmMDI.ActiveForm.Grid1.Text)
Next
      
Print #p, ""

' etykiety cech
Print #p, "[VARIABLE_LABEL]"
frmMDI.ActiveForm.Grid1.Row = 0
For j = 2 To frmMDI.ActiveForm.Grid1.Cols - 1
   frmMDI.ActiveForm.Grid1.Col = j
   Print #p, Trim$(frmMDI.ActiveForm.Grid1.Text)
Next

Print #p, ""

' dane
Print #p, "[DATA]"
For i = 1 To frmMDI.ActiveForm.Grid1.Rows - 1
   frmMDI.ActiveForm.Grid1.Row = i
   For j = 1 To frmMDI.ActiveForm.Grid1.Cols - 1
      frmMDI.ActiveForm.Grid1.Col = j
      If j > 1 Then
         If Trim$(frmMDI.ActiveForm.Grid1.Text) <> "N/A" Then
            Print #p, Format$(CSng(Trim$(frmMDI.ActiveForm.Grid1.Text)), "#0.000");
         Else
            Print #p, "N/A";
         End If
         If j < frmMDI.ActiveForm.Grid1.Cols - 1 Then
            Print #p, ";";
         End If
      End If
   Next
   Print #p, ""
Next

Close #p

' display hourglass
Screen.MousePointer = vbDefault

End Sub

'---------------------------------------------------------------------------------------
' Procedure : OpenDataNew
' DateTime  : 03-03-30 00:41
' Author    : Piotr
' Purpose   : open data file *.mdt (text version)
'---------------------------------------------------------------------------------------
'
Public Sub OpenDataNew(strFile As String)
Dim p As Integer
Dim intLoc As Integer, i As Integer, j As Integer
Dim strTemp As String
Dim strDescription As String  ' Description
Dim intRecCount As Integer    ' Record Count
Dim intVarCount As Integer    ' Variable Count
Dim fIndex As Integer

p = FreeFile
Open strFile For Input As #p
Line Input #p, strTemp

If Left$(strTemp, 11) <> "MaCzek DATA" Then
   MsgBox "This file has been created in older MaCzek version. You can save it only with new format.", vbExclamation, "MaCzek"
   Close #p
   Call OpenFileB(strFile)
   Exit Sub
End If

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[HEADER]" Then
   MsgBox "Error in HEADER section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "Description" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   strDescription = strTemp
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "RecCount" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intRecCount = CInt(strTemp)
End If

Line Input #p, strTemp
intLoc = InStr(strTemp, "=")
If Left$(strTemp, intLoc - 1) = "VarCount" Then
   strTemp = Mid$(strTemp, intLoc + 1, Len(strTemp) - intLoc)
   intVarCount = CInt(strTemp)
End If

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[RECORD_LABEL]" Then
   MsgBox "Error in RECORD_LABEL section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

ReDim RecInfo(1 To intRecCount)

For i = 1 To intRecCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   If Len(strTemp) > 15 Then strTemp = Left$(strTemp, 15)
   RecInfo(i) = Trim$(strTemp)
Next

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[VARIABLE_LABEL]" Then
   MsgBox "Error in VARIABLE_LABEL section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

ReDim Etykiety(1 To intVarCount)

For i = 1 To intVarCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   If Len(strTemp) > 8 Then strTemp = Left$(strTemp, 8)
   Etykiety(i) = Trim$(strTemp)
Next

Line Input #p, strTemp 'empty line

Line Input #p, strTemp
If Trim$(strTemp) <> "[DATA]" Then
   MsgBox "Error in DATA section of file: " & strFile, vbExclamation, "MaCzek"
   Close #p
   Exit Sub
End If

Dim strTempArray() As String
ReDim DaneMaczka(1 To intRecCount, 1 To intVarCount)

For i = 1 To intRecCount
   Line Input #p, strTemp
   strTemp = Trim$(strTemp)
   strTempArray = Split(strTemp, ";")
   For j = 1 To intVarCount
      If Trim$(strTempArray(j - 1)) <> "N/A" Then
         DaneMaczka(i, j) = CSng(Val(strTempArray(j - 1)))
      Else
         DaneMaczka(i, j) = gEmpty
      End If
   Next
Next

Close #p

fIndex = FindFreeIndex()
gIndex = fIndex
document(fIndex).Tag = fIndex
document(fIndex).Caption = "[DATA]: " & LCase$(strFile)
document(fIndex).OpisText = LTrim$(RTrim$(strDescription))

document(fIndex).Grid1.Cols = intVarCount + 2 'plus dwa poniewa dochodzi kolumna na etykiety
document(fIndex).Grid1.Rows = intRecCount + 1 'plus jeden poniewa dochodzi wiersz gowny z nazwami cech

document(fIndex).Grid1.Row = 0
document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.Text = "Number"

document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.COLWIDTH(0) = 900

Dim JakaSzer As Long, x%, y%

JakaSzer = 900

For x% = 1 To document(fIndex).Grid1.Rows - 1
  document(fIndex).Grid1.Row = x%
  document(fIndex).Grid1.Text = Str$(x%) 'numery wierszy z rekordami
Next x%

document(fIndex).Grid1.FixedAlignment(0) = 2 'wyrodkowanie numerw

document(fIndex).Grid1.Row = 0
For x% = 1 To document(fIndex).Grid1.Cols - 1
  If x% = 1 Then
    document(fIndex).Grid1.COLWIDTH(x%) = 1800
    JakaSzer = JakaSzer + 1800
    document(fIndex).Grid1.FixedAlignment(x%) = 0      'left aligned
    document(fIndex).Grid1.ColAlignment(x%) = 0      'left aligned
  Else
    document(fIndex).Grid1.COLWIDTH(x%) = 900
    JakaSzer = JakaSzer + 900
    document(fIndex).Grid1.FixedAlignment(x%) = 1      'right aligned
    document(fIndex).Grid1.ColAlignment(x%) = 1      'right aligned
  End If
  document(fIndex).Grid1.Col = x%
  If x% = 1 Then
    document(fIndex).Grid1.Text = "Record Name"
  Else
    document(fIndex).Grid1.Text = Etykiety(x% - 1)
  End If
Next x%

document(fIndex).Grid1.Col = 0
For i = 1 To document(fIndex).Grid1.Cols - 1
  document(fIndex).Grid1.FixedAlignment(i) = 2
Next

document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
For x% = 1 To document(fIndex).Grid1.Rows - 1
  document(fIndex).Grid1.Row = x%
  document(fIndex).Grid1.Text = RecInfo(x%)
Next x%

'deklaracja formatu wprowadzanych danych
Dim strFmt As String
strFmt = "###0.000"

For x% = 1 To document(fIndex).Grid1.Rows - 1
  For y% = 2 To document(fIndex).Grid1.Cols - 1
    document(fIndex).Grid1.Row = x%
    document(fIndex).Grid1.Col = y%
    If DaneMaczka(x%, y% - 1) <> gEmpty Then
      document(fIndex).Grid1.Text = Format$(DaneMaczka(x%, y% - 1), strFmt)
    Else
      document(fIndex).Grid1.Text = "N/A"
    End If
    'jesli szeroki tekst zwieksz szerokosc kolumny
    If Len(document(fIndex).Grid1.Text) > 8 Then
      document(fIndex).Grid1.COLWIDTH(y%) = 1200
    End If
  Next
Next

document(fIndex).Grid1.Visible = True
document(fIndex).TopPanel.Visible = True
document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
document(fIndex).Grid1.SetFocus
document(fIndex).SzerOkno = JakaSzer
document(fIndex).Grid1.SetFocus
FState(fIndex).Dirty = False
document(fIndex).WindowState = 0
If document(fIndex).WindowState = 0 Then
   document(fIndex).Height = 0.8 * Screen.Height
   document(fIndex).Width = 0.95 * Screen.Width
   document(fIndex).Top = 0
   document(fIndex).Left = 0
End If
document(fIndex).Show
    
' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub
